> ## Documentation Index
> Fetch the complete documentation index at: https://kernel.sh/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Discover WebMCP tools across the browser

> Returns a snapshot of native WebMCP tools available across every open tab and embedded frame
in the browser. Each tool includes an opaque tool_ref for invoking that exact live registration.
Tools disappear when their document closes or navigates away.




## OpenAPI

````yaml https://api.onkernel.com/spec.json get /browsers/{id_or_name}/webmcp/tools
openapi: 3.1.0
info:
  description: Developer tools and cloud infrastructure for AI agents to use web browsers
  title: Kernel API
  version: 0.1.0
servers:
  - description: API Server
    url: https://api.onkernel.com
security:
  - bearerAuth: []
tags:
  - description: Create and manage browser sessions.
    name: Browsers
  - description: Control mouse, keyboard, and screen on the browser instance.
    name: Browser Computer Controls
  - description: Execute Playwright code against the browser instance.
    name: Browser Playwright
  - description: Discover and invoke native page tools across the browser instance.
    name: Browser WebMCP
  - description: Read, write, and manage files on the browser instance.
    name: Browser Filesystem
  - description: Execute and manage processes on the browser instance.
    name: Browser Processes
  - description: Record and manage browser session video replays.
    name: Browser Replays
  - description: Stream logs from the browser instance.
    name: Browser Logs
  - description: >-
      Stream live telemetry events from a browser session, and manage the
      destinations sessions export them to.
    name: Browser Telemetry
  - description: Create, list, retrieve, and delete browser profiles.
    name: Profiles
  - description: Create and manage proxy configurations for routing browser traffic.
    name: Proxies
  - description: Create, list, retrieve, and delete browser extensions.
    name: Extensions
  - description: Create and manage browser pools for acquiring and releasing browsers.
    name: Browser Pools
  - description: Inspect the identity and authorization context for the current request.
    name: Authentication
  - description: >-
      Create and manage auth connections for automated credential capture and
      login.
    name: Managed Auth
  - description: Create and manage credentials for authentication.
    name: Credentials
  - description: Configure external credential providers like 1Password.
    name: Credential Providers
  - description: List applications and versions.
    name: Apps
  - description: Create and manage app deployments and stream deployment events.
    name: Deployments
  - description: Invoke actions and stream or query invocation status and events.
    name: Invocations
  - description: Read and manage organization-level limits.
    name: Organization
  - description: |
      Create and manage projects for resource isolation within an organization.
      When projects are disabled for the organization, project operations return
      `404` with code `projects_disabled`.
    name: Projects
  - description: Create and manage API keys for organization and project-scoped access.
    name: API Keys
  - description: Read audit log records for the authenticated organization.
    name: Audit Logs
  - description: Resolve browser and proxy recommendations for bot-protected sites.
    name: Config Registry
paths:
  /browsers/{id_or_name}/webmcp/tools:
    get:
      tags:
        - Browser WebMCP
      summary: Discover WebMCP tools across the browser
      description: >
        Returns a snapshot of native WebMCP tools available across every open
        tab and embedded frame

        in the browser. Each tool includes an opaque tool_ref for invoking that
        exact live registration.

        Tools disappear when their document closes or navigates away.
      operationId: listWebMCPTools
      parameters:
        - description: Browser session ID or name
          example: htzv5orfit78e1m2biiifpbv
          in: path
          name: id_or_name
          required: true
          schema:
            type: string
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/WebMCPToolsResponse'
          description: Current browser-wide WebMCP tool snapshot
        '404':
          $ref: '#/components/responses/NotFound'
        '500':
          $ref: '#/components/responses/InternalError'
        default:
          $ref: '#/components/responses/BrowserProxyError'
      security:
        - bearerAuth: []
components:
  schemas:
    WebMCPToolsResponse:
      additionalProperties: false
      properties:
        tools:
          items:
            $ref: '#/components/schemas/WebMCPTool'
          type: array
      required:
        - tools
      type: object
    WebMCPTool:
      additionalProperties: false
      properties:
        annotations:
          $ref: '#/components/schemas/WebMCPToolAnnotations'
        description:
          type: string
        input_schema:
          additionalProperties: true
          type: object
        name:
          type: string
        source:
          $ref: '#/components/schemas/WebMCPToolSource'
        tool_ref:
          description: >-
            Opaque reference for invoking this exact live registration. It
            becomes invalid when its document or browser process is replaced.
          type: string
      required:
        - tool_ref
        - name
        - description
        - input_schema
        - source
      type: object
    Error:
      properties:
        code:
          description: Application-specific error code (machine-readable)
          example: bad_request
          type: string
        details:
          description: Additional error details (for multiple errors)
          items:
            $ref: '#/components/schemas/ErrorDetail'
          type: array
        inner_error:
          $ref: '#/components/schemas/ErrorDetail'
        message:
          description: Human-readable error description for debugging
          example: 'Missing required field: app_name'
          type: string
      required:
        - code
        - message
      type: object
    InstanceProxyError:
      properties:
        code:
          $ref: '#/components/schemas/InstanceProxyErrorCode'
        message:
          description: Human-readable error description for debugging
          type: string
      required:
        - code
        - message
      type: object
    WebMCPToolAnnotations:
      additionalProperties: false
      description: >-
        Page-provided behavioral hints. These values are untrusted and are not
        enforced by Kernel.
      properties:
        autosubmit:
          type: boolean
        consequential:
          type: boolean
        read_only:
          type: boolean
        untrusted_content:
          type: boolean
      required:
        - read_only
        - untrusted_content
        - consequential
        - autosubmit
      type: object
    WebMCPToolSource:
      additionalProperties: false
      properties:
        frame:
          allOf:
            - $ref: '#/components/schemas/WebMCPToolFrame'
          description: >-
            Embedded frame that registered the tool, or null when the top-level
            page registered it.
          nullable: true
        page_title:
          description: Current title of the top-level page.
          type: string
        page_url:
          description: Current URL of the top-level page with the fragment omitted.
          type: string
        tab_id:
          description: >-
            Monotonically increasing identifier for the tab during the current
            browser process.
          minimum: 1
          type: integer
        window_id:
          description: >-
            Monotonically increasing identifier for the browser window during
            the current browser process.
          minimum: 1
          type: integer
      required:
        - window_id
        - tab_id
        - page_title
        - page_url
        - frame
      type: object
    ErrorDetail:
      properties:
        code:
          description: Lower-level error code providing more specific detail
          example: invalid_input
          type: string
        message:
          description: Further detail about the error
          example: Provided version string is not semver compliant
          type: string
      type: object
    InstanceProxyErrorCode:
      description: Canonical error code returned by browser instance API proxy routes
      enum:
        - invalid_request
        - unauthorized
        - forbidden
        - session_not_leased
        - not_found
        - conflict
        - session_gone
        - rate_limit_exceeded
        - internal_error
        - browser_unavailable
      type: string
    WebMCPToolFrame:
      additionalProperties: false
      properties:
        frame_id:
          description: >-
            Monotonically increasing identifier for this embedded frame during
            the current browser process.
          minimum: 1
          type: integer
        url:
          description: Current frame URL with the fragment omitted.
          type: string
      required:
        - frame_id
        - url
      type: object
  responses:
    NotFound:
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
      description: Resource not found
    InternalError:
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
      description: Internal Server Error
    BrowserProxyError:
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/InstanceProxyError'
      description: Error returned by the browser or its proxy
  securitySchemes:
    bearerAuth:
      scheme: bearer
      type: http

````